/* The Linux Channel
 * Code for Video Episode: 352 Linux user-space - Shared Memory IPC - Live Demo and Example
 * Author: Kiran Kankipati
 * Updated: 15-Jul-2018
 */
#include <stdlib.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <unistd.h>

#define SHM_MAX 1024

void main()
{   key_t key = ftok("shmfile",65); //generate unique key
 
    int shmid = shmget(key, SHM_MAX, 0666|IPC_CREAT); if(shmid<0) { printf("shmget() error! \n"); return; } //get shared memory
 
    unsigned char *buf = (unsigned char*) shmat(shmid, (void*)0, 0); //attach buf to shared memory

	 int j=0;
    while(1)
    {	for(j=0;j<10;j++) { printf("%02x ", buf[j]); } printf("\n\n"); //dump buf
    	sleep(2);
    } 
    
    shmdt(buf); //detach buf from shared memory

    shmctl(shmid, IPC_RMID, NULL); //destroy shared memory
}
